'use strict';

exports.__esModule = true;
exports.ElementMockup = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _aureliaPalNodejs = require('aurelia-pal-nodejs');

var pal = _interopRequireWildcard(_aureliaPalNodejs);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

pal.globalize();

var ElementClassListMock = function () {
    function ElementClassListMock() {
        _classCallCheck(this, ElementClassListMock);

        this.classes = [];
    }

    ElementClassListMock.prototype.add = function add(style) {
        this.classes.push(style);
    };

    ElementClassListMock.prototype.remove = function remove(style) {};

    return ElementClassListMock;
}();

var Validity = function () {
    _createClass(Validity, [{
        key: 'valid',
        get: function get() {
            return this._valid;
        },
        set: function set(value) {
            this._valid = value;
        }
    }]);

    function Validity() {
        _classCallCheck(this, Validity);

        this.valid = true;
    }

    return Validity;
}();

var Style = function () {
    function Style() {
        _classCallCheck(this, Style);
    }

    _createClass(Style, [{
        key: 'display',
        get: function get() {
            return this._display;
        },
        set: function set(value) {
            this._display = value;
        }
    }, {
        key: 'width',
        get: function get() {
            return this._width;
        },
        set: function set(value) {
            this._width = value;
        }
    }]);

    return Style;
}();

var ElementMockup = exports.ElementMockup = function () {
    _createClass(ElementMockup, [{
        key: 'childNodes',
        get: function get() {
            return this.children;
        }
    }]);

    function ElementMockup() {
        _classCallCheck(this, ElementMockup);

        this.attributes = new Map();
        this.children = [];
        this.classList = new ElementClassListMock();
        this.events = new Map();
        this.validity = new Validity();
        this.style = new Style();
    }

    ElementMockup.prototype.setAttribute = function setAttribute(attribute, value) {
        this.attributes.set(attribute, value);
    };

    ElementMockup.prototype.getAttribute = function getAttribute(attribute) {
        return this.attributes.get(attribute);
    };

    ElementMockup.prototype.removeAttribute = function removeAttribute(attribute) {
        this.attributes.delete(attribute);
    };

    ElementMockup.prototype.appendChild = function appendChild(child) {
        this.children.push(child);
    };

    ElementMockup.prototype.cloneNode = function cloneNode(inDepth) {
        var element = new ElementMockup();
        element.nodeType = this.nodeType;
        element.children = this.children.slice(0);
        element.innerHTML = this.innerHTML;

        return element;
    };

    ElementMockup.prototype.replaceChild = function replaceChild(newElement, oldElement) {
        return newElement;
    };

    ElementMockup.prototype.getElementById = function getElementById(id) {
        var child = this.children.find(function (item) {
            return item.id == id;
        });

        return child;
    };

    ElementMockup.prototype.querySelector = function querySelector(selector) {
        return new ElementMockup();
    };

    ElementMockup.prototype.addEventListener = function addEventListener(event, action) {
        this.events.set(event, action);
    };

    ElementMockup.prototype.removeEventListener = function removeEventListener(event, action) {
        if (this.events.has(event)) {
            this.events.delete(event);
        }
    };

    ElementMockup.prototype.dispatchEvent = function dispatchEvent(event) {};

    return ElementMockup;
}();

global.Element = new ElementMockup();
//# sourceMappingURL=element-mockup.js.map
